<?php
session_start();
Error_Reporting(0);
//Тип содержимого – картинка формата PNG 
header('Content-type: image/png');
 
// создаем картинку размером 160X50
$img = imagecreatetruecolor(160, 50) or die('Cannot create image');

// заполняем фон картинки белым цветом
imagefill($img, 0, 0, imagecolorallocate($img, rand(245, 255), rand(245, 255), rand(245, 255)));

// Создаём массив шрифтов
$dir = opendir('./fonts');
while($file = readdir($dir))
{
   if(($file != '.')&&($file != '..')&&($file != 'Thumbs.db'))
   {
      $fonts[] = './fonts/'.$file;
   }
}
closedir($dir);

// Формируем цифры на картинке
$font = $fonts[rand(0, count($fonts)-1)];// Задаём случайный шрифт
$sum = '';//Переменная для формировки цифр на картинке
$x=5;//Начальная координата оси X для текста
$i = 0;//начальный шаг для цикла
while ($i < 5)// выводим одну цифру за один проход цикла (всего 5 цифр)
{
   // выводим текст поверх картинки
   imagettftext(
   $img,          // идентификатор ресурса
   rand(16,25),   // размер шрифта в пикселях
   rand(-35,35),  // угол поворота текста
   $x, 30+rand(0,10), // координаты (x,y), соответствующие левому нижнему
                            // углу первого символа
   imagecolorallocate($img, rand(0,128), rand(0,128), rand(0,128)), // цвет шрифта
   $font, // имя файла со шрифтом
   $rnd=rand(0,9)); // случайная цифра от 0 до 9
   
   $x=$x+30;//увеличили отступ для следующего символа
   $sum = $sum.$rnd;// Собираем в одну строку все символы на картинке
   ++$i;//отметили шаг цикла
}

//сохраняем цифры в сессию 
$_SESSION['captcha'] = md5($sum);

// Формируем шум (линии)
$i = 0;//начальный шаг для цикла
while ($i < 6)// выводим линии
{
   imageline($img, rand(0, 50), rand(0, 50), rand(110, 160), rand(0, 50),
   imagecolorallocate($img, rand(0, 128), rand(0, 128), rand(0, 128)));
   ++$i;//отметили шаг цикла
}

// выводим готовую картинку в формате PNG
imagepng($img);

// освобождаем память, выделенную для картинки
imagedestroy($img);
?>