/*
Визуальный редактор для My-Engine CMS
http://my-engine.ru/
*/

function setWinDocGecko(set){
	/*Определим Gecko-браузеры, т.к. они отличаются в своей работе от Оперы и IE*/
    var isGecko = navigator.userAgent.toLowerCase().indexOf("gecko") != -1;
    // Получаем доступ к объектам window & document для ифрейма
    var iframe = (isGecko) ? document.getElementById("frameId") : frames["frameId"];
    var iWin = (isGecko) ? iframe.contentWindow : iframe.window;
    var iDoc = (isGecko) ? iframe.contentDocument : iframe.document;
    
    if(set == "gecko"){var rezult = isGecko;}
    if(set == "win"){var rezult = iWin;}
    if(set == "doc"){var rezult = iDoc;}
    return rezult;
}


function wysiwyg(id, w, h, color, margin, bordercolor, bordersize){
	document.getElementById(id).style.display = "none";
	var top = margin * 2 + 16;
	
	
    document.open();
    document.write('<div id="visual_editor" style="background-color: '+color+'; border: '+bordersize+'px solid '+bordercolor+'; width:'+w+'; padding:0px;">');
    document.write('<div id="visual_editor_wysiwyg" style="margin: 0px; padding:0px;">');
        
        
        document.write('<div style="background-image: url(wysiwyg/icon/bg.png); background-repeat: repeat-x; background-position: bottom; margin: 0px; padding: 0px;">');
        /*Начало тулбара*/
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setBold();" title="Выделение жирным текстом" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/bold.gif" border="0" alt="Выделение жирным текстом" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setItal();" title="Наклонный текст" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/italic.gif" border="0" alt="Наклонный текст" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setUnder();" title="Подчёркнутый текст" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/underline.gif" border="0" alt="Подчёркнутый текст" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        
        document.write('<div style="float: left; margin: 0px; padding:0px; position: relative;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextFont\').style.display = \'\'; "  title="Шрифт текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/font.gif" alt="Шрифт текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a>');
        document.write('<div id="setTextFont" style="display: none; position: absolute; z-index: 99; top: '+top+'px; left: 0px; background-color: #ffffff; width: 200px; border: 1px solid '+color+'; border-top: 0px; font: 11px Verdana,sans-serif; margin: 0px; padding:0px;">');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Impact\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Impact">Impact</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Arial Black\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Arial Black">Arial Black</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Arial\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Arial">Arial</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Lucida Sans Unicode\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Lucida Sans Unicode">Lucida Sans Unicode</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Microsoft Sans Serif\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Microsoft Sans Serif">Microsoft Sans Serif</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Tahoma\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Tahoma">Tahoma</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Times New Roman\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Times New Roman">Times New Roman</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Verdana\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Verdana">Verdana</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Courier New\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Courier New">Courier New</font></a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextFont(\'Comic Sans MS\'); document.getElementById(\'setTextFont\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;"><font face="Comic Sans MS">Comic Sans MS</font></a></div>');
        document.write('<div style="background-color: '+color+'; margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextFont\').style.display = \'none\';" style="display: block; margin: 0px; padding:0px; text-decoration:none; color: #000000;"><b>Отмена</b></a></div>');
        document.write('</div>');
        document.write('</div>');
        
        document.write('<div style="float: left; margin: 0px; padding:0px; position: relative;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextColor\').style.display = \'\';"  title="Цвет текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/text_color.gif" alt="Цвет текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a>');
        document.write('<div id="setTextColor" style="display: none; position: absolute; z-index: 99; top: '+top+'px; left: 0px; background-color: #ffffff; width: 200px; border: 1px solid '+color+'; border-top: 0px; font: 11px Verdana,sans-serif; margin: 0px; padding:0px;">');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextColor(\'#000000\'); document.getElementById(\'setTextColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Чёрный(#000000)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextColor(\'#999999\'); document.getElementById(\'setTextColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #999999;">Серый(#999999)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextColor(\'#FF0000\'); document.getElementById(\'setTextColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #FF0000;">Красный(#FF0000)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextColor(\'#00FF00\'); document.getElementById(\'setTextColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #00FF00;">Зелёный(#00FF00)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextColor(\'#0000FF\'); document.getElementById(\'setTextColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #0000FF;">Синий(#0000FF)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextColor(\'#FFF000\'); document.getElementById(\'setTextColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #FFF000;">Желтый(#FFF000)</a></div>');
        document.write('<div style="background-color: '+color+'; margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextColor\').style.display = \'none\';" style="display: block; margin: 0px; padding:0px; text-decoration:none; color: #000000;"><b>Отмена</b></a></div>');
        document.write('</div>');
        document.write('</div>');
        
        document.write('<div style="float: left; margin: 0px; padding:0px; position: relative;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextBgColor\').style.display = \'\';"  title="Цвет фона текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/text_bg_color.gif" alt="Цвет фона текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a>');
        document.write('<div id="setTextBgColor" style="display: none; position: absolute; z-index: 99; top: '+top+'px; left: 0px; background-color: #ffffff; width: 200px; border: 1px solid '+color+'; border-top: 0px; font: 11px Verdana,sans-serif; margin: 0px; padding:0px;">');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextBgColor(\'#000000\'); document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Чёрный(#000000)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextBgColor(\'#999999\'); document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #999999;">Серый(#999999)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextBgColor(\'#FF0000\'); document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #FF0000;">Красный(#FF0000)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextBgColor(\'#00FF00\'); document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #00FF00;">Зелёный(#00FF00)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextBgColor(\'#0000FF\'); document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #0000FF;">Синий(#0000FF)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextBgColor(\'#FFF000\'); document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #FFF000;">Желтый(#FFF000)</a></div>');
        document.write('<div style="background-color: '+color+'; margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextBgColor\').style.display = \'none\';" style="display: block; margin: 0px; padding:0px; text-decoration:none; color: #000000;"><b>Отмена</b></a></div>');
        document.write('</div>');
        document.write('</div>');
        
        document.write('<div style="float: left; margin: 0px; padding:0px; position: relative;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextSize\').style.display = \'\';"  title="Размер текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/text_size.gif" alt="Размер текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a>');
        document.write('<div id="setTextSize" style="display: none; position: absolute; z-index: 99; top: '+top+'px; left: 0px; background-color: #ffffff; width: 200px; border: 1px solid '+color+'; border-top: 0px; font: 11px Verdana,sans-serif; margin: 0px; padding:0px;">');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'1\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Мелкий(1pt)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'2\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Маленький(2pt)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'3\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Небольшой(3pt)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'4\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Обычный(4pt)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'5\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Большой(5pt)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'6\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Крупный(6pt)</a></div>');
        document.write('<div style="margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="setTextSize(\'7\'); document.getElementById(\'setTextSize\').style.display = \'none\';" style="margin: 0px; padding:0px; text-decoration:none; color: #000000;">Огромный(7pt)</a></div>');
        document.write('<div style="background-color: '+color+'; margin: 0px; padding:2px;"><a href="javascript:void(0)" onClick="document.getElementById(\'setTextSize\').style.display = \'none\';" style="display: block; margin: 0px; padding:0px; text-decoration:none; color: #000000;"><b>Отмена</b></a></div>');
        document.write('</div>');
        document.write('</div>');
        
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setLeft();" title="Выравнивание по левому краю" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/align_left.gif" alt="Выравнивание по левому краю" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setCenter();" title="Выравнивание по центру" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/align_center.gif" alt="Выравнивание по центру" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setRight();" title="Выравнивание по правому краю" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/align_right.gif" alt="Выравнивание по правому краю" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setFull();" title="Выравнивание по ширине" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/align_full.gif" alt="Выравнивание по ширине" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setLink();" title="Создать ссылку" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/insert_link.gif" alt="Создать ссылку" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setUnLink();" title="Разорвать ссылку" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/remove_link.gif" alt="Разорвать ссылку" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setImg();" title="Вставить картинку" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/img.gif" alt="Вставить картинку" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setOrderedList();" title="Нумерованный список" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/ordered_list.gif" alt="Нумерованный список" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setUnorderedList();" title="Маркерованный список" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/unordered_list.gif" alt="Маркерованный список" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setIndent();" title="Увеличить отступ текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/indent.gif" alt="Увеличить отступ текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setOutdent();" title="Уменьшить отступ текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/outdent.gif" alt="Уменьшить отступ текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="setRemoveFormat();" title="Убрать форматирование выделенного текста" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/remove_format.gif" alt="Убрать форматирование выделенного текста" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="document.getElementById(\'visual_editor_wysiwyg\').style.display = \'none\'; document.getElementById(\'visual_editor_html\').style.display = \'\'; html();" title="Исходный html код" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/html.gif" alt="Исходный html код" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        
        document.write('<div style="margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="info();" title="Информация" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/info.gif" border="0" alt="Информация" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        
        /*Конец тулбара*/
        document.write('</div>');
        document.write('<iframe id="frameId" name="frameId" frameborder="0" style="clear:both; border-width: 0px; width:100%; height:'+h+'; margin: 0px; padding:0px;"></iframe>');
        
    document.write('</div>');
    
    document.write('<div id="visual_editor_html" style="display: none; margin: 0px; padding:0px;">');
        
        document.write('<div style="background-image: url(wysiwyg/icon/bg.png); background-repeat: repeat-x; background-position: bottom; margin: 0px; padding: 0px;">');
        /*Начало тулбара*/
        document.write('<div style="float: left; margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="document.getElementById(\'visual_editor_html\').style.display = \'none\'; document.getElementById(\'visual_editor_wysiwyg\').style.display = \'\'; checkHtml();" title="Применить" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/html_ok.gif" alt="Применить" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        document.write('<div style="margin: 0px; padding:0px;"><a href="javascript:void(0)" onClick="document.getElementById(\'visual_editor_html\').style.display = \'none\'; document.getElementById(\'visual_editor_wysiwyg\').style.display = \'\';" title="Отмена" style="margin: 0px; padding:0px;"><img src="wysiwyg/icon/html_no.gif" alt="Отмена" style="border-width: 0px; margin: '+margin+'px; padding:0px;"></a></div>');
        /*Конец тулбара*/
        document.write('</div>');
        document.write('<textarea id="visual_editor_html_textarea" style="clear:both; border-width: 0px; background-color:#FFFFE0; font: 12px Courier New, sans-serif; color: #555555; width:100%; height:'+h+'; margin: 0px; padding:0px;"></textarea>');
        
    document.write('</div>');
    document.write('</div>');
    document.close();
    
    
    
    isGecko = setWinDocGecko("gecko");
    iDoc = setWinDocGecko("doc");
    if (!iDoc.designMode) alert("Визуальный режим редактирования не поддерживается Вашим браузером, рекомендуем установить один из следующих браузеров: FireFox 3.5.*, Opera 10.*, Google Chrome");
    else iDoc.designMode = (isGecko) ? "on" : "On";
    
    iHTML = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    iHTML += "<html>\n";
    iHTML += "<head>\n";
    iHTML += "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
    iHTML += "<style type=\"text/css\">\n";
    iHTML += "body {margin:5px; padding:0px; background-color:#FFFFFF; font-size:12px; font-family:tahoma;}\n";
    iHTML += "</style>\n";
    iHTML += "</head>\n";
    iHTML += "<body>" + document.getElementById(id).value + "</body>\n";
    iHTML += "</html>";
    iDoc.open();
    iDoc.write(iHTML);
    iDoc.close();
}


//////////////////////////////////////////////////////// Функции редактирования текста
function setBold(){
	iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("bold", null, "");
}
function setItal(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("italic", null, "");
}
function setUnder(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("underline", null, "");
}
function setLeft(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("JustifyLeft", null, "");
}
function setCenter(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("JustifyCenter", null, "");
}
function setRight(){
	iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("JustifyRight", null, "");
}
function setFull(){
	iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("JustifyFull", null, "");
}
//////////////////////////////////////////////////////////Удаление тегов форматирования
function setRemoveFormat(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("RemoveFormat", null, "");
}
//////////////////////////////////////////////////////////создание ссылки
function setLink(){
    iWin = setWinDocGecko("win");
    var url = prompt("Введите URL ссылки:", "http://");
    if(url)
    {
       iWin.focus();
       iWin.document.execCommand("CreateLink", null, url);
    }else
    {
       return;
    }
}
//////////////////////////////////////////////////////////удаление ссылки
function setUnLink(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("Unlink", null, "");
}
//////////////////////////////////////////////////////////картинка
function setImg(){
    iWin = setWinDocGecko("win");
    var url = prompt("Введите URL картинки:", "http://");
    if(url)
    {
       iWin.focus();
       iWin.document.execCommand("InsertImage", null, url);
    }else
    {
       return;
    }
}
///////////////////////////////////////////////////////////шрифты
function setTextFont(font){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("FontName", null, font);
}
///////////////////////////////////////////////////////////цвета текста
function setTextColor(color){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("ForeColor", null, color);
}
///////////////////////////////////////////////////////////цвет фона текста
function setTextBgColor(color){
    isGecko = setWinDocGecko("gecko");
    iWin = setWinDocGecko("win");
    iWin.focus();
    if(isGecko){iWin.document.execCommand("hilitecolor", false, color);}//Для мозилы
    else{iWin.document.execCommand("BackColor", false, color);}//для других
}
///////////////////////////////////////////////////////////Размер текста
function setTextSize(size){
	iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("Fontsize", null, size);
}
/////////////////////////////////////////////////////////списки
function setOrderedList(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("InsertOrderedList", null, "");
}
function setUnorderedList(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("InsertUnorderedList", null, "");
}
/////////////////////////////////////////////////////////отступы
function setIndent(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("Indent", null, "");
}
function setOutdent(){
    iWin = setWinDocGecko("win");
    iWin.focus();
    iWin.document.execCommand("Outdent", null, "");
}
/////////////////////////////////////////////////////////Функция для открытия html кода
function html(){
    iDoc = setWinDocGecko("doc");
    document.getElementById("visual_editor_html_textarea").value = iDoc.body.innerHTML;
}
/////////////////////////////////////////////////////////Функция применения нового html кода
function checkHtml(){
    iDoc = setWinDocGecko("doc");
    iDoc.body.innerHTML = document.getElementById("visual_editor_html_textarea").value;
}
/////////////////////////////////////////////////////////Функция обновления
function check(id){
    iDoc = setWinDocGecko("doc");
    
    if(document.getElementById("visual_editor_wysiwyg").style.display == "none")
    {
       if(confirm("ВНИМАНИЕ!\n\nБыли сделаны именения в исходном коде страницы, вы уверены в том, что хотите сохранить эти изменения?\n\nНажмите OK что-бы сохранить!"))
       {
          iDoc.body.innerHTML = document.getElementById("visual_editor_html_textarea").value;
          var rezult = true;
       }else{
          var rezult = false;
       }
    }else
    {
        var rezult = true;
    }
    
    if(rezult)
    {
       document.getElementById(id).value = iDoc.body.innerHTML;
    }
    
    return rezult;
}
////////////////////////////////////////////////////////////Информация
function info(){
    alert("Горячие клавиши:\nОтмена действий - Ctrl + Z\nПовтор действий - Ctrl + Y\nКопировать текст - Ctrl + C\nВставить текст - Ctrl + V\n\nРедактор был разработан специально для My-Engine CMS\n2010 - 2011 г.");
}

